Option Strict On
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading

'This application displays the contents of the data portion of UDP datagrams received on a specified port.
'The socket uses the non-blocking BeginReceive method, which calls the ReceiveCallback routine 
'when there is received data.

'This file and other embedded Ethernet and Internet code and resources are
'available from www.Lvr.com.



Public Class Form1
    Inherits System.Windows.Forms.Form
    Friend Shared connectDone As New ManualResetEvent(False)
    Friend continuousReceive As Boolean = False
    Friend receiveInProgress As Boolean = False
    Public Delegate Sub DisplayResultsDelegate(ByVal Text As Integer, ByRef dataBuffer() As Byte)
    Dim DisplayResultsMarshaler As DisplayResultsDelegate = AddressOf Me.DisplayResults
    Dim setupChanged As Boolean
    Public udpSocket As New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnOneTimeReceive As System.Windows.Forms.Button
    Friend WithEvents btnStopContinuousReceive As System.Windows.Forms.Button
    Friend WithEvents btnStartContinuousReceive As System.Windows.Forms.Button
    Public WithEvents txtLog As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtLog = New System.Windows.Forms.TextBox
        Me.btnOneTimeReceive = New System.Windows.Forms.Button
        Me.btnStartContinuousReceive = New System.Windows.Forms.Button
        Me.btnStopContinuousReceive = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'txtLog
        '
        Me.txtLog.AutoSize = False
        Me.txtLog.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtLog.Location = New System.Drawing.Point(16, 16)
        Me.txtLog.Multiline = True
        Me.txtLog.Name = "txtLog"
        Me.txtLog.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtLog.Size = New System.Drawing.Size(760, 424)
        Me.txtLog.TabIndex = 0
        Me.txtLog.Text = ""
        '
        'btnOneTimeReceive
        '
        Me.btnOneTimeReceive.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnOneTimeReceive.Location = New System.Drawing.Point(552, 464)
        Me.btnOneTimeReceive.Name = "btnOneTimeReceive"
        Me.btnOneTimeReceive.Size = New System.Drawing.Size(232, 40)
        Me.btnOneTimeReceive.TabIndex = 1
        Me.btnOneTimeReceive.Text = "One-time Receive"
        '
        'btnStartContinuousReceive
        '
        Me.btnStartContinuousReceive.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnStartContinuousReceive.Location = New System.Drawing.Point(16, 464)
        Me.btnStartContinuousReceive.Name = "btnStartContinuousReceive"
        Me.btnStartContinuousReceive.Size = New System.Drawing.Size(232, 40)
        Me.btnStartContinuousReceive.TabIndex = 2
        Me.btnStartContinuousReceive.Text = "Start Continuous Receive"
        '
        'btnStopContinuousReceive
        '
        Me.btnStopContinuousReceive.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnStopContinuousReceive.Location = New System.Drawing.Point(280, 464)
        Me.btnStopContinuousReceive.Name = "btnStopContinuousReceive"
        Me.btnStopContinuousReceive.Size = New System.Drawing.Size(232, 40)
        Me.btnStopContinuousReceive.TabIndex = 3
        Me.btnStopContinuousReceive.Text = "Stop Continuous Receive"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(792, 515)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnStopContinuousReceive, Me.btnStartContinuousReceive, Me.btnOneTimeReceive, Me.txtLog})
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub
#End Region

    Friend Sub GetLocalHostInfo()
        'The port the remote computer will send to.
        Dim intLocalPort As Integer = 5550

        'Specify the IP addresses and ports to use and bind the local port to the local IP address.
        Try
            'To get the local host's IP address,
            'first get the host name and its local host(s).
            Dim strLocalHostName As String = System.Net.Dns.GetHostName()

            'IPHostEntry contains a list of the local hosts
            '(there may be more than one) and their IP addresses.
            Dim myIPHostEntry As IPHostEntry = System.Net.Dns.GetHostByName(strLocalHostName)

            'Use the first host in the list.
            Dim localIPAddress As IPAddress = myIPHostEntry.AddressList(0)

            'Use the local IP address and port to define a local endpoint.
            Dim LocalIPEndpoint As New IPEndPoint(localIPAddress, intLocalPort)

            'Tell the UDP socket to use the specified port number.
            udpSocket.Bind(LocalIPEndpoint)

            'Display information about the local computer:
            txtLog.Text = "Local host:  IP Address " & localIPAddress.ToString & ", Port " & CStr(intLocalPort) & ControlChars.CrLf

        Catch e As Exception
            MessageBox.Show(e.ToString)
        End Try

    End Sub

    Friend Function PrepareToExchangeData(ByVal udpSocket As Socket) As Boolean

        'The port the remote computer will send to.
        Dim intLocalPort As Integer = 5550
        Dim ReadyToExchangeData As Boolean = False

        'Specify the IP addresses and ports to use and bind the local port to the local IP address.
        Try
            ReadyToExchangeData = True

            txtLog.AppendText("Waiting for UDP datagrams.." & ControlChars.CrLf)
            setupChanged = False
            Return ReadyToExchangeData

        Catch e As Exception
            MessageBox.Show(e.ToString)
        End Try
    End Function

    Friend Sub ReceiveDataFromRemoteHost()
        Static Dim ReadyToExchangeData As Boolean

        Try
            'If the local and remote IP addresses and ports haven't been specified,
            'do so.
            If ((ReadyToExchangeData = False) Or (setupChanged = True)) Then
                'If ReadyToExchangeData = False Then
                ReadyToExchangeData = PrepareToExchangeData(udpSocket)
            End If

            'Retrieve any received data.
            If ReadyToExchangeData = True Then
                Do
                    'Attempt to receive data.
                    'Set receiveInProgress True to prevent another attempt to receive data
                    'until this receive attempt has completed.
                    If receiveInProgress = False Then
                        receiveInProgress = True
                        Receive(udpSocket)
                    End If

                    'The btnStartContinuousReceive_Click routine doesn't return until the user 
                    'clicks Stop Continuous Receive.
                    'DoEvents enables the text box to display received data before the 
                    'routine returns.
                    System.Windows.Forms.Application.DoEvents()

                    'If the user has clicked Start Continuous Receive, wait for more data.
                Loop While continuousReceive = True
            Else
                txtLog.Text = "connection failed" & ControlChars.CrLf
            End If

        Catch e As Exception
            MessageBox.Show(e.ToString)
        End Try
    End Sub

    Private Sub btnOneTimeReceive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOneTimeReceive.Click

        'Receive one datagram.
        ReceiveDataFromRemoteHost()
    End Sub

    Private Sub btnStartContinuousReceive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartContinuousReceive.Click
        'Start receiving data continuously.

        'Disable the Start button and enable the Stop button.
        btnStartContinuousReceive.Enabled = False
        btnStopContinuousReceive.Enabled = True

        'continuousReceive tells the main program loop to continue waiting for received datagrams.
        continuousReceive = True
        ReceiveDataFromRemoteHost()
    End Sub

    Private Sub btnStopContinuousReceive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStopContinuousReceive.Click

        'Stop receiving data continuously.
        continuousReceive = False

        'Disable the Stop button and enable the Start button.
        btnStopContinuousReceive.Enabled = False
        btnStartContinuousReceive.Enabled = True

    End Sub

    Private Sub DisplayResults(ByVal Text As Integer, ByRef dataBuffer() As Byte)
        Dim count As Integer

        'Display received bytes in the text box.
        For count = 0 To (Text - 1)

            'Display received data as bytes:
            Me.txtLog.AppendText(dataBuffer(count) & " ")

            'Display received data as text:
            'Me.txtLog.AppendText(Chr(dataBuffer(count)))
        Next count

        'Go to the next line in the text box.
        Me.txtLog.AppendText(ControlChars.CrLf)
        receiveInProgress = False
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'The StopContinuousReceive button is enabled only after clicking the StartContinuousReceive button.
        btnStopContinuousReceive.Enabled = False
        Me.Show()
        GetLocalHostInfo()
    End Sub

    Private Sub Receive(ByVal udpSocket As Socket)

        'Call udpSocket's BeginReceive method to start waiting for received data.
        Try
            Dim receivedData As New socketData
            receivedData.workSocket = udpSocket

            'Wait for data from the remote host.
            'ReceiveCallback is called when a datagram has arrived.
            'Pass receivedData, which contains udpSocket, to the callback.
            udpSocket.BeginReceive _
            (receivedData.socketDataBuffer, 0, receivedData.socketDataBufferLength, 0, _
              AddressOf ReceiveCallback, receivedData)
        Catch e As Exception
            MessageBox.Show(e.ToString)
        End Try
    End Sub

    Private Sub ReceiveCallback(ByVal ar As IAsyncResult)

        'This routine is called after calling BeginReceive, 
        'when a datagram  has arrived at the specified socket. 
        'ar.asyncstate is a socketData structure that contains the received data.
        Try

            'Convert the passed IAsyncResult to socketData.
            Dim state As socketData = CType(ar.AsyncState, socketData)

            'Read the received data.
            Dim numberOfBytesReceived As Integer = state.workSocket.EndReceive(ar)

            'Call the DisplayResults routine to display the received data in a text box on the Form.
            'Use Invoke with a delegate to make the call in the form's thread.
            'args is the object containing the information that DisplayResults will use.
            Dim args() As Object = {numberOfBytesReceived, state.socketDataBuffer}
            MyBase.Invoke(DisplayResultsMarshaler, args)
        Catch e As Exception
            MessageBox.Show(e.ToString)
        End Try
    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Me.Dispose()
    End Sub

    Private Sub txtLocalPort_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        setupChanged = True
    End Sub
End Class
